
#include <stdlib.h>
#include <stdio.h>
#include <string.h>



#define __SDK_ADDRCODE__ 0x4010
#define __SDK_ADDRDATA__ 0xC000
#define __SDK_MSXVERSION__ 2
#define __SDK_CRT0__ crt032K.rel
#define __SDK_EXT__ ROM 
#define __SDK_ROMSIZE__ 0x8000
#define __SDK_OPTIMIZATION__ 1


#define             RealTimer()   (*(unsigned int *)0xFC9E)

const unsigned char font[] =
{
// Sprite[0] (offset:0)
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x00, /* ........ */ 
// Sprite[1] (offset:8)
  0x30, /* ..##.... */ 
  0x30, /* ..##.... */ 
  0x30, /* ..##.... */ 
  0x20, /* ..#..... */ 
  0x00, /* ........ */ 
  0x20, /* ..#..... */ 
  0x00, /* ........ */ 
  0x00, /* ........ */ 
// Sprite[2] (offset:16)
  0xD8, /* ##.##... */ 
  0xD8, /* ##.##... */ 
  0x48, /* .#..#... */ 
  0x90, /* #..#.... */ 
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x00, /* ........ */ 
// Sprite[3] (offset:24)
  0x32, /* ..##..#. */ 
  0x64, /* .##..#.. */ 
  0xFE, /* #######. */ 
  0x64, /* .##..#.. */ 
  0xFE, /* #######. */ 
  0x64, /* .##..#.. */ 
  0xC8, /* ##..#... */ 
  0x00, /* ........ */ 
// Sprite[4] (offset:32)
  0x10, /* ...#.... */ 
  0x3C, /* ..####.. */ 
  0x52, /* .#.#..#. */ 
  0x38, /* ..###... */ 
  0x94, /* #..#.#.. */ 
  0x78, /* .####... */ 
  0x10, /* ...#.... */ 
  0x00, /* ........ */ 
// Sprite[5] (offset:40)
  0x42, /* .#....#. */ 
  0xA4, /* #.#..#.. */ 
  0x48, /* .#..#... */ 
  0x10, /* ...#.... */ 
  0x24, /* ..#..#.. */ 
  0x4A, /* .#..#.#. */ 
  0x84, /* #....#.. */ 
  0x00, /* ........ */ 
// Sprite[6] (offset:48)
  0x70, /* .###.... */ 
  0xC8, /* ##..#... */ 
  0xC8, /* ##..#... */ 
  0x70, /* .###.... */ 
  0xCA, /* ##..#.#. */ 
  0xC4, /* ##...#.. */ 
  0x7A, /* .####.#. */ 
  0x00, /* ........ */ 
// Sprite[7] (offset:56)
  0x60, /* .##..... */ 
  0x60, /* .##..... */ 
  0x20, /* ..#..... */ 
  0x40, /* .#...... */ 
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x00, /* ........ */ 
// Sprite[8] (offset:64)
  0x08, /* ....#... */ 
  0x10, /* ...#.... */ 
  0x30, /* ..##.... */ 
  0x30, /* ..##.... */ 
  0x30, /* ..##.... */ 
  0x10, /* ...#.... */ 
  0x08, /* ....#... */ 
  0x00, /* ........ */ 
// Sprite[9] (offset:72)
  0x20, /* ..#..... */ 
  0x10, /* ...#.... */ 
  0x18, /* ...##... */ 
  0x18, /* ...##... */ 
  0x18, /* ...##... */ 
  0x10, /* ...#.... */ 
  0x20, /* ..#..... */ 
  0x00, /* ........ */ 
// Sprite[10] (offset:80)
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x44, /* .#...#.. */ 
  0x28, /* ..#.#... */ 
  0x10, /* ...#.... */ 
  0x28, /* ..#.#... */ 
  0x44, /* .#...#.. */ 
  0x00, /* ........ */ 
// Sprite[11] (offset:88)
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x10, /* ...#.... */ 
  0x10, /* ...#.... */ 
  0x7C, /* .#####.. */ 
  0x10, /* ...#.... */ 
  0x10, /* ...#.... */ 
  0x00, /* ........ */ 
// Sprite[12] (offset:96)
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x60, /* .##..... */ 
  0x60, /* .##..... */ 
  0x20, /* ..#..... */ 
  0x40, /* .#...... */ 
// Sprite[13] (offset:104)
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x7C, /* .#####.. */ 
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x00, /* ........ */ 
// Sprite[14] (offset:112)
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x60, /* .##..... */ 
  0x60, /* .##..... */ 
  0x00, /* ........ */ 
// Sprite[15] (offset:120)
  0x02, /* ......#. */ 
  0x04, /* .....#.. */ 
  0x08, /* ....#... */ 
  0x10, /* ...#.... */ 
  0x20, /* ..#..... */ 
  0x40, /* .#...... */ 
  0x80, /* #....... */ 
  0x00, /* ........ */ 
// Sprite[16] (offset:128)
  0x10, /* ...#.... */ 
  0x28, /* ..#.#... */ 
  0x64, /* .##..#.. */ 
  0x64, /* .##..#.. */ 
  0x64, /* .##..#.. */ 
  0x28, /* ..#.#... */ 
  0x10, /* ...#.... */ 
  0x00, /* ........ */ 
// Sprite[17] (offset:136)
  0x18, /* ...##... */ 
  0x38, /* ..###... */ 
  0x58, /* .#.##... */ 
  0x18, /* ...##... */ 
  0x18, /* ...##... */ 
  0x18, /* ...##... */ 
  0x7C, /* .#####.. */ 
  0x00, /* ........ */ 
// Sprite[18] (offset:144)
  0x38, /* ..###... */ 
  0x4C, /* .#..##.. */ 
  0x0C, /* ....##.. */ 
  0x18, /* ...##... */ 
  0x30, /* ..##.... */ 
  0x60, /* .##..... */ 
  0x7C, /* .#####.. */ 
  0x00, /* ........ */ 
// Sprite[19] (offset:152)
  0x38, /* ..###... */ 
  0x4C, /* .#..##.. */ 
  0x0C, /* ....##.. */ 
  0x18, /* ...##... */ 
  0x0C, /* ....##.. */ 
  0x4C, /* .#..##.. */ 
  0x38, /* ..###... */ 
  0x00, /* ........ */ 
// Sprite[20] (offset:160)
  0x10, /* ...#.... */ 
  0x20, /* ..#..... */ 
  0x58, /* .#.##... */ 
  0x7C, /* .#####.. */ 
  0x18, /* ...##... */ 
  0x18, /* ...##... */ 
  0x18, /* ...##... */ 
  0x00, /* ........ */ 
// Sprite[21] (offset:168)
  0x7C, /* .#####.. */ 
  0x40, /* .#...... */ 
  0x78, /* .####... */ 
  0x4C, /* .#..##.. */ 
  0x0C, /* ....##.. */ 
  0x4C, /* .#..##.. */ 
  0x38, /* ..###... */ 
  0x00, /* ........ */ 
// Sprite[22] (offset:176)
  0x38, /* ..###... */ 
  0x44, /* .#...#.. */ 
  0x40, /* .#...... */ 
  0x78, /* .####... */ 
  0x4C, /* .#..##.. */ 
  0x4C, /* .#..##.. */ 
  0x38, /* ..###... */ 
  0x00, /* ........ */ 
// Sprite[23] (offset:184)
  0x7C, /* .#####.. */ 
  0x0C, /* ....##.. */ 
  0x0C, /* ....##.. */ 
  0x18, /* ...##... */ 
  0x18, /* ...##... */ 
  0x30, /* ..##.... */ 
  0x30, /* ..##.... */ 
  0x00, /* ........ */ 
// Sprite[24] (offset:192)
  0x38, /* ..###... */ 
  0x4C, /* .#..##.. */ 
  0x4C, /* .#..##.. */ 
  0x38, /* ..###... */ 
  0x4C, /* .#..##.. */ 
  0x4C, /* .#..##.. */ 
  0x38, /* ..###... */ 
  0x00, /* ........ */ 
// Sprite[25] (offset:200)
  0x38, /* ..###... */ 
  0x4C, /* .#..##.. */ 
  0x4C, /* .#..##.. */ 
  0x3C, /* ..####.. */ 
  0x0C, /* ....##.. */ 
  0x4C, /* .#..##.. */ 
  0x38, /* ..###... */ 
  0x00, /* ........ */ 
// Sprite[26] (offset:208)
  0x00, /* ........ */ 
  0x60, /* .##..... */ 
  0x60, /* .##..... */ 
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x60, /* .##..... */ 
  0x60, /* .##..... */ 
  0x00, /* ........ */ 
// Sprite[27] (offset:216)
  0x00, /* ........ */ 
  0x60, /* .##..... */ 
  0x60, /* .##..... */ 
  0x00, /* ........ */ 
  0x60, /* .##..... */ 
  0x60, /* .##..... */ 
  0x20, /* ..#..... */ 
  0x40, /* .#...... */ 
// Sprite[28] (offset:224)
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x10, /* ...#.... */ 
  0x20, /* ..#..... */ 
  0x40, /* .#...... */ 
  0x20, /* ..#..... */ 
  0x10, /* ...#.... */ 
  0x00, /* ........ */ 
// Sprite[29] (offset:232)
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x7C, /* .#####.. */ 
  0x00, /* ........ */ 
  0x7C, /* .#####.. */ 
  0x00, /* ........ */ 
  0x00, /* ........ */ 
// Sprite[30] (offset:240)
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x20, /* ..#..... */ 
  0x10, /* ...#.... */ 
  0x08, /* ....#... */ 
  0x10, /* ...#.... */ 
  0x20, /* ..#..... */ 
  0x00, /* ........ */ 
// Sprite[31] (offset:248)
  0x38, /* ..###... */ 
  0x4C, /* .#..##.. */ 
  0x0C, /* ....##.. */ 
  0x18, /* ...##... */ 
  0x10, /* ...#.... */ 
  0x00, /* ........ */ 
  0x10, /* ...#.... */ 
  0x00, /* ........ */ 
// Sprite[32] (offset:256)
  0x38, /* ..###... */ 
  0x64, /* .##..#.. */ 
  0xCE, /* ##..###. */ 
  0xCA, /* ##..#.#. */ 
  0xCC, /* ##..##.. */ 
  0x60, /* .##..... */ 
  0x38, /* ..###... */ 
  0x00, /* ........ */ 
// Sprite[33] (offset:264)
  0x30, /* ..##.... */ 
  0x68, /* .##.#... */ 
  0x68, /* .##.#... */ 
  0xFC, /* ######.. */ 
  0x68, /* .##.#... */ 
  0x6A, /* .##.#.#. */ 
  0xC4, /* ##...#.. */ 
  0x00, /* ........ */ 
// Sprite[34] (offset:272)
  0xB8, /* #.###... */ 
  0x64, /* .##..#.. */ 
  0x64, /* .##..#.. */ 
  0x7C, /* .#####.. */ 
  0x62, /* .##...#. */ 
  0x62, /* .##...#. */ 
  0xAC, /* #.#.##.. */ 
  0x00, /* ........ */ 
// Sprite[35] (offset:280)
  0x38, /* ..###... */ 
  0x64, /* .##..#.. */ 
  0xC0, /* ##...... */ 
  0xC0, /* ##...... */ 
  0xC2, /* ##....#. */ 
  0x64, /* .##..#.. */ 
  0xB8, /* #.###... */ 
  0x00, /* ........ */ 
// Sprite[36] (offset:288)
  0xF8, /* #####... */ 
  0x64, /* .##..#.. */ 
  0x62, /* .##...#. */ 
  0x62, /* .##...#. */ 
  0x62, /* .##...#. */ 
  0x62, /* .##...#. */ 
  0xFC, /* ######.. */ 
  0x00, /* ........ */ 
// Sprite[37] (offset:296)
  0x38, /* ..###... */ 
  0x64, /* .##..#.. */ 
  0xC0, /* ##...... */ 
  0x60, /* .##..... */ 
  0xC2, /* ##....#. */ 
  0xC4, /* ##...#.. */ 
  0x78, /* .####... */ 
  0x00, /* ........ */ 
// Sprite[38] (offset:304)
  0x7E, /* .######. */ 
  0xB2, /* #.##..#. */ 
  0x30, /* ..##.... */ 
  0x38, /* ..###... */ 
  0x30, /* ..##.... */ 
  0xB0, /* #.##.... */ 
  0x60, /* .##..... */ 
  0x00, /* ........ */ 
// Sprite[39] (offset:312)
  0x38, /* ..###... */ 
  0x64, /* .##..#.. */ 
  0xC0, /* ##...... */ 
  0xC4, /* ##...#.. */ 
  0xCA, /* ##..#.#. */ 
  0xE2, /* ###...#. */ 
  0x7C, /* .#####.. */ 
  0x00, /* ........ */ 
// Sprite[40] (offset:320)
  0xC2, /* ##....#. */ 
  0x64, /* .##..#.. */ 
  0x64, /* .##..#.. */ 
  0x7C, /* .#####.. */ 
  0x64, /* .##..#.. */ 
  0x64, /* .##..#.. */ 
  0xC6, /* ##...##. */ 
  0x00, /* ........ */ 
// Sprite[41] (offset:328)
  0x70, /* .###.... */ 
  0x30, /* ..##.... */ 
  0x30, /* ..##.... */ 
  0x30, /* ..##.... */ 
  0x30, /* ..##.... */ 
  0x30, /* ..##.... */ 
  0x78, /* .####... */ 
  0x00, /* ........ */ 
// Sprite[42] (offset:336)
  0x7E, /* .######. */ 
  0x9A, /* #..##.#. */ 
  0x18, /* ...##... */ 
  0x0C, /* ....##.. */ 
  0x4C, /* .#..##.. */ 
  0x9C, /* #..###.. */ 
  0x78, /* .####... */ 
  0x00, /* ........ */ 
// Sprite[43] (offset:344)
  0x82, /* #.....#. */ 
  0x64, /* .##..#.. */ 
  0x64, /* .##..#.. */ 
  0x6C, /* .##.##.. */ 
  0x74, /* .###.#.. */ 
  0x6A, /* .##.#.#. */ 
  0xE2, /* ###...#. */ 
  0x00, /* ........ */ 
// Sprite[44] (offset:352)
  0xC0, /* ##...... */ 
  0x60, /* .##..... */ 
  0x60, /* .##..... */ 
  0x60, /* .##..... */ 
  0x60, /* .##..... */ 
  0x72, /* .###..#. */ 
  0xDC, /* ##.###.. */ 
  0x00, /* ........ */ 
// Sprite[45] (offset:360)
  0x68, /* .##.#... */ 
  0xD4, /* ##.#.#.. */ 
  0xD4, /* ##.#.#.. */ 
  0xD4, /* ##.#.#.. */ 
  0xC4, /* ##...#.. */ 
  0xC6, /* ##...##. */ 
  0xC4, /* ##...#.. */ 
  0x00, /* ........ */ 
// Sprite[46] (offset:368)
  0x62, /* .##...#. */ 
  0x74, /* .###.#.. */ 
  0x74, /* .###.#.. */ 
  0x6C, /* .##.##.. */ 
  0x6C, /* .##.##.. */ 
  0x64, /* .##..#.. */ 
  0xC4, /* ##...#.. */ 
  0x00, /* ........ */ 
// Sprite[47] (offset:376)
  0x38, /* ..###... */ 
  0x4C, /* .#..##.. */ 
  0x66, /* .##..##. */ 
  0x86, /* #....##. */ 
  0x86, /* #....##. */ 
  0x4C, /* .#..##.. */ 
  0x38, /* ..###... */ 
  0x00, /* ........ */ 
// Sprite[48] (offset:384)
  0x7C, /* .#####.. */ 
  0xB2, /* #.##..#. */ 
  0x32, /* ..##..#. */ 
  0x3C, /* ..####.. */ 
  0x30, /* ..##.... */ 
  0x30, /* ..##.... */ 
  0x60, /* .##..... */ 
  0x00, /* ........ */ 
// Sprite[49] (offset:392)
  0x3A, /* ..###.#. */ 
  0x46, /* .#...##. */ 
  0x62, /* .##...#. */ 
  0xC2, /* ##....#. */ 
  0xC6, /* ##...##. */ 
  0x46, /* .#...##. */ 
  0x3A, /* ..###.#. */ 
  0x02, /* ......#. */ 
// Sprite[50] (offset:400)
  0x7C, /* .#####.. */ 
  0xB2, /* #.##..#. */ 
  0x32, /* ..##..#. */ 
  0x3C, /* ..####.. */ 
  0x34, /* ..##.#.. */ 
  0x36, /* ..##.##. */ 
  0x64, /* .##..#.. */ 
  0x00, /* ........ */ 
// Sprite[51] (offset:408)
  0x78, /* .####... */ 
  0xC4, /* ##...#.. */ 
  0xC0, /* ##...... */ 
  0x7C, /* .#####.. */ 
  0x06, /* .....##. */ 
  0x86, /* #....##. */ 
  0x7C, /* .#####.. */ 
  0x00, /* ........ */ 
// Sprite[52] (offset:416)
  0x7E, /* .######. */ 
  0xB2, /* #.##..#. */ 
  0x30, /* ..##.... */ 
  0x30, /* ..##.... */ 
  0x30, /* ..##.... */ 
  0x30, /* ..##.... */ 
  0x18, /* ...##... */ 
  0x00, /* ........ */ 
// Sprite[53] (offset:424)
  0x62, /* .##...#. */ 
  0xE4, /* ###..#.. */ 
  0x64, /* .##..#.. */ 
  0x64, /* .##..#.. */ 
  0x64, /* .##..#.. */ 
  0x64, /* .##..#.. */ 
  0x38, /* ..###... */ 
  0x00, /* ........ */ 
// Sprite[54] (offset:432)
  0x64, /* .##..#.. */ 
  0xE2, /* ###...#. */ 
  0x62, /* .##...#. */ 
  0x62, /* .##...#. */ 
  0x62, /* .##...#. */ 
  0x34, /* ..##.#.. */ 
  0x18, /* ...##... */ 
  0x00, /* ........ */ 
// Sprite[55] (offset:440)
  0x64, /* .##..#.. */ 
  0xE2, /* ###...#. */ 
  0x62, /* .##...#. */ 
  0x6A, /* .##.#.#. */ 
  0x6A, /* .##.#.#. */ 
  0x7E, /* .######. */ 
  0x34, /* ..##.#.. */ 
  0x00, /* ........ */ 
// Sprite[56] (offset:448)
  0x64, /* .##..#.. */ 
  0xB6, /* #.##.##. */ 
  0x34, /* ..##.#.. */ 
  0x38, /* ..###... */ 
  0x34, /* ..##.#.. */ 
  0xB6, /* #.##.##. */ 
  0x64, /* .##..#.. */ 
  0x00, /* ........ */ 
// Sprite[57] (offset:456)
  0x42, /* .#....#. */ 
  0xA6, /* #.#..##. */ 
  0x26, /* ..#..##. */ 
  0x26, /* ..#..##. */ 
  0x1E, /* ...####. */ 
  0x46, /* .#...##. */ 
  0x3C, /* ..####.. */ 
  0x00, /* ........ */ 
// Sprite[58] (offset:464)
  0xFE, /* #######. */ 
  0x8C, /* #...##.. */ 
  0x18, /* ...##... */ 
  0x10, /* ...#.... */ 
  0x20, /* ..#..... */ 
  0x6C, /* .##.##.. */ 
  0xF2, /* ####..#. */ 
  0x00, /* ........ */ 
// Sprite[59] (offset:472)
  0x18, /* ...##... */ 
  0x10, /* ...#.... */ 
  0x10, /* ...#.... */ 
  0x10, /* ...#.... */ 
  0x10, /* ...#.... */ 
  0x10, /* ...#.... */ 
  0x18, /* ...##... */ 
  0x00, /* ........ */ 
// Sprite[60] (offset:480)
  0x80, /* #....... */ 
  0x40, /* .#...... */ 
  0x20, /* ..#..... */ 
  0x10, /* ...#.... */ 
  0x08, /* ....#... */ 
  0x04, /* .....#.. */ 
  0x02, /* ......#. */ 
  0x00, /* ........ */ 
// Sprite[61] (offset:488)
  0x18, /* ...##... */ 
  0x08, /* ....#... */ 
  0x08, /* ....#... */ 
  0x08, /* ....#... */ 
  0x08, /* ....#... */ 
  0x08, /* ....#... */ 
  0x18, /* ...##... */ 
  0x00, /* ........ */ 
// Sprite[62] (offset:496)
  0x00, /* ........ */ 
  0x10, /* ...#.... */ 
  0x28, /* ..#.#... */ 
  0x28, /* ..#.#... */ 
  0x44, /* .#...#.. */ 
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x00, /* ........ */ 
// Sprite[63] (offset:504)
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x02, /* ......#. */ 
  0x7C, /* .#####.. */ 
  0x80, /* #....... */ 
// Sprite[64] (offset:512)
  0x60, /* .##..... */ 
  0x60, /* .##..... */ 
  0x40, /* .#...... */ 
  0x20, /* ..#..... */ 
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x00, /* ........ */ 
// Sprite[65] (offset:520)
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x38, /* ..###... */ 
  0x04, /* .....#.. */ 
  0x3C, /* ..####.. */ 
  0x44, /* .#...#.. */ 
  0x3C, /* ..####.. */ 
  0x00, /* ........ */ 
// Sprite[66] (offset:528)
  0x20, /* ..#..... */ 
  0x20, /* ..#..... */ 
  0x38, /* ..###... */ 
  0x24, /* ..#..#.. */ 
  0x24, /* ..#..#.. */ 
  0x24, /* ..#..#.. */ 
  0x58, /* .#.##... */ 
  0x00, /* ........ */ 
// Sprite[67] (offset:536)
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x38, /* ..###... */ 
  0x44, /* .#...#.. */ 
  0x40, /* .#...... */ 
  0x44, /* .#...#.. */ 
  0x38, /* ..###... */ 
  0x00, /* ........ */ 
// Sprite[68] (offset:544)
  0x08, /* ....#... */ 
  0x08, /* ....#... */ 
  0x38, /* ..###... */ 
  0x48, /* .#..#... */ 
  0x48, /* .#..#... */ 
  0x48, /* .#..#... */ 
  0x34, /* ..##.#.. */ 
  0x00, /* ........ */ 
// Sprite[69] (offset:552)
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x38, /* ..###... */ 
  0x44, /* .#...#.. */ 
  0x7C, /* .#####.. */ 
  0x40, /* .#...... */ 
  0x38, /* ..###... */ 
  0x00, /* ........ */ 
// Sprite[70] (offset:560)
  0x38, /* ..###... */ 
  0x44, /* .#...#.. */ 
  0x40, /* .#...... */ 
  0xF0, /* ####.... */ 
  0x40, /* .#...... */ 
  0x40, /* .#...... */ 
  0x80, /* #....... */ 
  0x00, /* ........ */ 
// Sprite[71] (offset:568)
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x3C, /* ..####.. */ 
  0x44, /* .#...#.. */ 
  0x44, /* .#...#.. */ 
  0x3C, /* ..####.. */ 
  0x04, /* .....#.. */ 
  0x08, /* ....#... */ 
// Sprite[72] (offset:576)
  0x40, /* .#...... */ 
  0x40, /* .#...... */ 
  0x58, /* .#.##... */ 
  0x64, /* .##..#.. */ 
  0x44, /* .#...#.. */ 
  0x44, /* .#...#.. */ 
  0x84, /* #....#.. */ 
  0x00, /* ........ */ 
// Sprite[73] (offset:584)
  0x10, /* ...#.... */ 
  0x00, /* ........ */ 
  0x10, /* ...#.... */ 
  0x10, /* ...#.... */ 
  0x10, /* ...#.... */ 
  0x10, /* ...#.... */ 
  0x08, /* ....#... */ 
  0x00, /* ........ */ 
// Sprite[74] (offset:592)
  0x10, /* ...#.... */ 
  0x00, /* ........ */ 
  0x10, /* ...#.... */ 
  0x30, /* ..##.... */ 
  0x10, /* ...#.... */ 
  0x10, /* ...#.... */ 
  0x10, /* ...#.... */ 
  0x20, /* ..#..... */ 
// Sprite[75] (offset:600)
  0x40, /* .#...... */ 
  0x40, /* .#...... */ 
  0x48, /* .#..#... */ 
  0x68, /* .##.#... */ 
  0x50, /* .#.#.... */ 
  0x68, /* .##.#... */ 
  0xC8, /* ##..#... */ 
  0x00, /* ........ */ 
// Sprite[76] (offset:608)
  0x20, /* ..#..... */ 
  0x30, /* ..##.... */ 
  0x30, /* ..##.... */ 
  0x30, /* ..##.... */ 
  0x30, /* ..##.... */ 
  0x20, /* ..#..... */ 
  0x10, /* ...#.... */ 
  0x00, /* ........ */ 
// Sprite[77] (offset:616)
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0xD0, /* ##.#.... */ 
  0xF8, /* #####... */ 
  0xA8, /* #.#.#... */ 
  0xA8, /* #.#.#... */ 
  0xAC, /* #.#.##.. */ 
  0x00, /* ........ */ 
// Sprite[78] (offset:624)
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x60, /* .##..... */ 
  0x78, /* .####... */ 
  0x48, /* .#..#... */ 
  0x48, /* .#..#... */ 
  0x4C, /* .#..##.. */ 
  0x00, /* ........ */ 
// Sprite[79] (offset:632)
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x70, /* .###.... */ 
  0xA8, /* #.#.#... */ 
  0x98, /* #..##... */ 
  0x88, /* #...#... */ 
  0x70, /* .###.... */ 
  0x00, /* ........ */ 
// Sprite[80] (offset:640)
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x1C, /* ...###.. */ 
  0x32, /* ..##..#. */ 
  0x12, /* ...#..#. */ 
  0x12, /* ...#..#. */ 
  0x1C, /* ...###.. */ 
  0x10, /* ...#.... */ 
// Sprite[81] (offset:648)
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x38, /* ..###... */ 
  0x48, /* .#..#... */ 
  0x48, /* .#..#... */ 
  0x4C, /* .#..##.. */ 
  0x38, /* ..###... */ 
  0x08, /* ....#... */ 
// Sprite[82] (offset:656)
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x58, /* .#.##... */ 
  0x24, /* ..#..#.. */ 
  0x20, /* ..#..... */ 
  0x20, /* ..#..... */ 
  0x40, /* .#...... */ 
  0x00, /* ........ */ 
// Sprite[83] (offset:664)
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x38, /* ..###... */ 
  0x40, /* .#...... */ 
  0x38, /* ..###... */ 
  0x84, /* #....#.. */ 
  0x78, /* .####... */ 
  0x00, /* ........ */ 
// Sprite[84] (offset:672)
  0x20, /* ..#..... */ 
  0x20, /* ..#..... */ 
  0x70, /* .###.... */ 
  0x20, /* ..#..... */ 
  0x20, /* ..#..... */ 
  0x24, /* ..#..#.. */ 
  0x18, /* ...##... */ 
  0x00, /* ........ */ 
// Sprite[85] (offset:680)
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x48, /* .#..#... */ 
  0x48, /* .#..#... */ 
  0x48, /* .#..#... */ 
  0x48, /* .#..#... */ 
  0x34, /* ..##.#.. */ 
  0x00, /* ........ */ 
// Sprite[86] (offset:688)
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x48, /* .#..#... */ 
  0x44, /* .#...#.. */ 
  0x44, /* .#...#.. */ 
  0x28, /* ..#.#... */ 
  0x10, /* ...#.... */ 
  0x00, /* ........ */ 
// Sprite[87] (offset:696)
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x48, /* .#..#... */ 
  0x44, /* .#...#.. */ 
  0x44, /* .#...#.. */ 
  0x54, /* .#.#.#.. */ 
  0x28, /* ..#.#... */ 
  0x00, /* ........ */ 
// Sprite[88] (offset:704)
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x6C, /* .##.##.. */ 
  0x92, /* #..#..#. */ 
  0x10, /* ...#.... */ 
  0x92, /* #..#..#. */ 
  0x6C, /* .##.##.. */ 
  0x00, /* ........ */ 
// Sprite[89] (offset:712)
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x44, /* .#...#.. */ 
  0xA8, /* #.#.#... */ 
  0x28, /* ..#.#... */ 
  0x18, /* ...##... */ 
  0x08, /* ....#... */ 
  0x30, /* ..##.... */ 
// Sprite[90] (offset:720)
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x78, /* .####... */ 
  0x10, /* ...#.... */ 
  0x20, /* ..#..... */ 
  0x40, /* .#...... */ 
  0xF8, /* #####... */ 
  0x04, /* .....#.. */ 
// Sprite[91] (offset:728)
  0x18, /* ...##... */ 
  0x20, /* ..#..... */ 
  0x20, /* ..#..... */ 
  0x40, /* .#...... */ 
  0x20, /* ..#..... */ 
  0x20, /* ..#..... */ 
  0x18, /* ...##... */ 
  0x00, /* ........ */ 
// Sprite[92] (offset:736)
  0x08, /* ....#... */ 
  0x10, /* ...#.... */ 
  0x10, /* ...#.... */ 
  0x10, /* ...#.... */ 
  0x10, /* ...#.... */ 
  0x10, /* ...#.... */ 
  0x20, /* ..#..... */ 
  0x00, /* ........ */ 
// Sprite[93] (offset:744)
  0x60, /* .##..... */ 
  0x10, /* ...#.... */ 
  0x10, /* ...#.... */ 
  0x08, /* ....#... */ 
  0x10, /* ...#.... */ 
  0x10, /* ...#.... */ 
  0x60, /* .##..... */ 
  0x00, /* ........ */ 
// Sprite[94] (offset:752)
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x24, /* ..#..#.. */ 
  0x54, /* .#.#.#.. */ 
  0x48, /* .#..#... */ 
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x00, /* ........ */ 
// Sprite[95] (offset:760)
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x00, /* ........ */ 
  0x00, /* ........ */ 
};

// Fast VDP Command parameters structure
typedef struct {
  unsigned int sx;    // source X (0 to 511)      R32 &   R33
  unsigned int sy;    // source Y (0 to 1023)     R34 & R34
  unsigned int dx;    // destination X (0 to 511)   R36 & R37
  unsigned int dy;    // destination Y (0 to 1023)  R38 & R39
  unsigned int nx;    // width (0 to 511)       R40 & R41
  unsigned int ny;    // height (0 to 511)      R42 & R43
  unsigned char col;    // color used by some commands. R44 
  unsigned char param;  // Parameters set the direction. Example opDOWN | opRIGHT     R45
  unsigned char cmd;    // VDP Command + Logical Operator : Like opLMMM | LOGICAL_XOR R46

  void *address; // Suppose to contain Bitmap data's address in ram
} FastVDP;


// Print Bitmap Structure. Store Bitmap Data and Color Table also other parameters
typedef struct { 
    char letter_data;
    unsigned int x;
    unsigned int y;
    char Mtemp[8][8]; 
    char TabColor[16][4];
    char letter;
    unsigned int letter_addr;
} GraphPrint; 

GraphPrint BitmapFont;
FastVDP VDPcmd;

void WaitKey(void)
{
  __asm

  push ix
  ld ix, #0x09F   ;chget bios function 
    ld iy, (0xFCC0) ; mainrom slotaddress 
    call 0x001c   ; interslotcall
    ei
    ld   l,a      ; Return value to L 
    ld   h,#0
    pop  ix
    ret
    __endasm;
}




void Screen(char n) __naked
{
  n;
 __asm
          xor   a
          ld    hl, #0xFAF5   ;;  DPPAGE
          ld    (hl), a
          inc   hl            ;;  ACPAGE
          ld    (hl), a

          ld    hl, #2
          add   hl, sp

          ld    a, (hl)       ;;  mode
          ld    hl,#0xFCAF    ;; Save current mode to FCAF 
          ld    (hl),a
          push  ix
          ld    ix, #0x005f   ;;  chgmod with call bios
          ld    iy, (0xFCC0)  ; mainrom slotaddress 
            call  0x001c      ; interslotcall
            ei
            pop ix
            ret
  __endasm;
}
// Set BitMapt color Array  
void SetBitmapFontColor(char ForeColor, char BackColor)
{
  char ntab[][]= {{BackColor,BackColor,BackColor,BackColor},
                  {BackColor,BackColor,BackColor,ForeColor},
                  {BackColor,BackColor,ForeColor,BackColor},
                  {BackColor,BackColor,ForeColor,ForeColor},
                  {BackColor,ForeColor,BackColor,BackColor},
                  {BackColor,ForeColor,BackColor,ForeColor},
                  {BackColor,ForeColor,ForeColor,BackColor},
                  {BackColor,ForeColor,ForeColor,ForeColor},
                  {ForeColor,BackColor,BackColor,BackColor},
                  {ForeColor,BackColor,BackColor,ForeColor},
                  {ForeColor,BackColor,ForeColor,BackColor},
                  {ForeColor,BackColor,ForeColor,ForeColor},
                  {ForeColor,ForeColor,BackColor,BackColor},
                  {ForeColor,ForeColor,BackColor,ForeColor},
                  {ForeColor,ForeColor,ForeColor,BackColor},
                  {ForeColor,ForeColor,ForeColor,ForeColor}};

  memcpy(*BitmapFont.TabColor, *ntab, 64 );
}


// Fast VDP use of LMMM or HMMM for 8x8 pattern
void FastChar(void *Params)  __z88dk_fastcall  __naked    
{
  Params;
    __asm 

      di
      fvdpWait1:
      ld  a,#2
      out (#0x99),a           
      ld  a,#128+#15
      out (#0x99),a
      in  a,(#0x99)
      rrca
      jp  c, fvdpWait1         ; wait CE
      
      ld  a,#32               ; Start with Reg 32
      out (#0x99),a
      ld  a,#128+#17
      out (#0x99),a           ;R#17 := 32

      ld  bc,#0x0f9b            ; c=9b   b=0f
      OUTI
      OUTI
      OUTI
      OUTI
      OUTI
      OUTI
      OUTI
      OUTI
      OUTI
      OUTI
      OUTI
      OUTI
      OUTI
      OUTI
      OUTI         
  
      ld  a,#128+#44
      out (#0x99),a
      ld  a,#128+#17
      out (#0x99),a       ; VDP(17)<=44

//------------- PROBLEM --------------------------------
// ICI HL devrait avoir le contenu de BitmapFont.Mtemp
// C'est à dire l'addresse du tablau Mtemp où sont les données Bitmpa à afficher.
// Enlève le commentaire de la ligne suivante pour voir le résultat que je veux avoir 

   //ld hl,#_BitmapFont+5 
      ld b,#64             ; Number of bytes to send
      otir
  

      ;exit
      xor a
      out (#0x99),a
      ld  a,#0x8f
      ei
      out (#0x99),a
      ret
        
     __endasm;
}


// Decode Font Bytes
void PrintBitmapChar(void)
{
 
  char y=0;
    while (y < 8)
    {
        BitmapFont.letter_data = font[BitmapFont.letter_addr++];
        memcpy(&BitmapFont.Mtemp[y][0],&BitmapFont.TabColor[BitmapFont.letter_data >> 4],4);
        memcpy(&BitmapFont.Mtemp[y][4],&BitmapFont.TabColor[BitmapFont.letter_data & 0b00001111],4);
        y++;
    }
   
   
   FastChar(&VDPcmd);

}


void PrintBitmap(char *string, unsigned int x, unsigned int y)
{
      char i=0;

      // VDP parameters
      VDPcmd.dy=y;    // Destination X
      VDPcmd.dx=x;    // Destinatio Y

     while (string[i])          // Send Each Letter to the print Bitmap function
     {
         BitmapFont.letter=string[i]-32;
         BitmapFont.letter_addr=BitmapFont.letter * 8;
         PrintBitmapChar();

         i++;
         VDPcmd.dx+=8;
      } 
}



void main(void)
  {
   
    char i;
    unsigned int a,b;
 
    i=0;


    Screen(5);
  

    SetBitmapFontColor(10,0);
    
  

    // Set Default VDP command parameters
    VDPcmd.nx=8;
    VDPcmd.ny=8;
    VDPcmd.col=0;
    VDPcmd.param=0;
    VDPcmd.cmd=0xb0;

//------------- PROBLEM --------------------------------
    VDPcmd.address=&BitmapFont.Mtemp;
//------------- PROBLEM --------------------------------

    SetBitmapFontColor(9,0);
    

    a=RealTimer();
   
    PrintBitmap("Bonjour le futur !",10,10);
    PrintBitmap("ICI LE MSX QUI VOUS PARLE",10,20);
    PrintBitmap("DEPUIS L'ANNEE 1985",10,30);
    PrintBitmap("IL PARAIT QUE LES VIEUX",10,40);
    //   SetBitmapFontColor(0,12);
    PrintBitmap("JOUENT ENCORE AVEC MOI",10,50);
    PrintBitmap("DANS LES ANNEES 2020 ?",10,60);
    PrintBitmap("Incroyable !",10,70);

    b=RealTimer();
    

   



WaitKey();
Screen(0);
printf("Time: %d",b-a);



WaitKey();

}